/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: mcontext_tPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the mcontext_tPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=mcontext_t.class)
public class mcontext_tPointer extends StructurePointer {

	// NULL
	public static final mcontext_tPointer NULL = new mcontext_tPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected mcontext_tPointer(long address) {
		super(address);
	}

	public static mcontext_tPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static mcontext_tPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static mcontext_tPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new mcontext_tPointer(address);
	}

	public mcontext_tPointer add(long count) {
		return mcontext_tPointer.cast(address + (mcontext_t.SIZEOF * count));
	}

	public mcontext_tPointer add(Scalar count) {
		return add(count.longValue());
	}

	public mcontext_tPointer addOffset(long offset) {
		return mcontext_tPointer.cast(address + offset);
	}

	public mcontext_tPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public mcontext_tPointer sub(long count) {
		return mcontext_tPointer.cast(address - (mcontext_t.SIZEOF * count));
	}

	public mcontext_tPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public mcontext_tPointer subOffset(long offset) {
		return mcontext_tPointer.cast(address - offset);
	}

	public mcontext_tPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public mcontext_tPointer untag(long mask) {
		return mcontext_tPointer.cast(address & ~mask);
	}

	public mcontext_tPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return mcontext_t.SIZEOF;
	}

	// Implementation methods

	// I32 __pad0
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="___pad0Offset_", declaredType="I32")
	public IDATA __pad0() throws CorruptDataException {
		return new I32(getIntAtOffset(mcontext_t.___pad0Offset_));
	}

	// I32 __pad0
	public IDATAPointer __pad0EA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(mcontext_t.___pad0Offset_));
	}

	// U64[] __unused
	public UDATAPointer __unusedEA() throws CorruptDataException {
		return U64Pointer.cast(nonNullFieldEA(mcontext_t.___unusedOffset_));
	}

	// fpregset_t fp_regs
	public DoublePointer fp_regsEA() throws CorruptDataException {
		return DoublePointer.cast(nonNullFieldEA(mcontext_t._fp_regsOffset_));
	}

	// gregset_t gp_regs
	public UDATAPointer gp_regsEA() throws CorruptDataException {
		return U64Pointer.cast(nonNullFieldEA(mcontext_t._gp_regsOffset_));
	}

	// U64 handler
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_handlerOffset_", declaredType="U64")
	public UDATA handler() throws CorruptDataException {
		return new U64(getLongAtOffset(mcontext_t._handlerOffset_));
	}

	// U64 handler
	public UDATAPointer handlerEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(mcontext_t._handlerOffset_));
	}

	// U64 oldmask
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_oldmaskOffset_", declaredType="U64")
	public UDATA oldmask() throws CorruptDataException {
		return new U64(getLongAtOffset(mcontext_t._oldmaskOffset_));
	}

	// U64 oldmask
	public UDATAPointer oldmaskEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(mcontext_t._oldmaskOffset_));
	}

	// pt_regs* regs
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_regsOffset_", declaredType="pt_regs*")
	public pt_regsPointer regs() throws CorruptDataException {
		return pt_regsPointer.cast(getPointerAtOffset(mcontext_t._regsOffset_));
	}

	// pt_regs* regs
	public PointerPointer regsEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(mcontext_t._regsOffset_));
	}

	// I32 signal
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_signalOffset_", declaredType="I32")
	public IDATA signal() throws CorruptDataException {
		return new I32(getIntAtOffset(mcontext_t._signalOffset_));
	}

	// I32 signal
	public IDATAPointer signalEA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(mcontext_t._signalOffset_));
	}

	// vrregset_t* v_regs
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_v_regsOffset_", declaredType="vrregset_t*")
	public _libc_vrstatePointer v_regs() throws CorruptDataException {
		return _libc_vrstatePointer.cast(getPointerAtOffset(mcontext_t._v_regsOffset_));
	}

	// vrregset_t* v_regs
	public PointerPointer v_regsEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(mcontext_t._v_regsOffset_));
	}

	// I64[] vmx_reserve
	public IDATAPointer vmx_reserveEA() throws CorruptDataException {
		return I64Pointer.cast(nonNullFieldEA(mcontext_t._vmx_reserveOffset_));
	}

}
